# -*- encoding: utf-8 -*-
__Autor__ = "Luiz Fernando"
__Empresa__ = "Sig Informatica Ltda"
__Site__ = "http://www.siginformatica.com.br"
__Versao__ = "1.03"
__DataAlteracao__ = "30/12/2015"
import sys

if __name__ == '__main__':
    try:
        if sys.argv[1] == '-9':
            print(('impressao.py\t\tVersao:' + __Versao__ + '\tData:'+ __DataAlteracao__) +
                  '\tImpressao em pdf')
        else:
            print(('\n\nimpressao.py - impressao em pdf \n' + 'Versao: '+ __Versao__ + '\n' +
                   'Data: ' + __DataAlteracao__ + '\n'))
    except:
        print(('\n\nimpressao.py - Impressao em pdf \n' +'Versao: '+ __Versao__ + '\n'
            +'Data: '+ __DataAlteracao__ + '\n'))

from reportlab.lib.units import cm, inch
from reportlab.pdfgen import canvas
from SigUtils.formatastring import formataString
from SigUtils.datas import sigDatas
import re

def center_cab(esquerda='', centro='', direita='', tamanho=160, fillchar=' '):
    tam_cab = len(esquerda) + len(centro) + len(direita)
    tam_esp = (tamanho - tam_cab)
    titulo = esquerda + int(tam_esp / 2) * fillchar + centro + (tam_esp - (int(tam_esp / 2))) * fillchar + direita
    return titulo


class Linha(object):
    """
    Define uma linha do relatório
    """
    class Coluna(object):
        def __init__(self):
            self.cab=''
            self.tipo_dados='S' #S=String, N=Numero, V=Valor, D=Data
            self.dado=''
            self.tam_int=0
            self.tam_dec=0
            self.tam_tot=0
            self.alinhamento='E' #E=Esquerda, C=Centro, D=Direita
            self.posicao=0
        def incluirColuna(self, cab, tipo, tamanho, posicao, alinhamento):
            self.alinhamento=alinhamento.upper()
            if not self.alinhamento in ('E', 'C', 'D'):
                return False
            self.tipo_dados=tipo.upper()
            if not self.tipo_dados in ('S', 'N', 'V', 'D'):
                return False
            listaTam=str(tamanho).replace('.', ',').split(',')
            try:
                self.posicao=int(posicao)

                if tipo.upper() == 'V':
                    if len(listaTam) != 2:
                        return False
                    self.tam_int=int(listaTam[0])
                    self.tam_dec=int(listaTam[1])
                    self.tam_tot=self.tam_dec+1+self.tam_int
                else:
                    self.tam_int=int(tamanho)
                    self.tam_tot=int(tamanho)
            except:
                return False
            self.cab=formataString(cab, self.tam_tot, ' ',self.alinhamento, 'N', 'S')
            return True
        
    def __init__(self):
        """
            Inicializa a classe para definição de uma linha
        """
        self.__qtdColunas=0
        self.__proximaColuna=0
        self.__dic_coluna={}
        self.__ultimaPosicao=0
    def incluirColuna(self, cab, tipo, tamanho, posicao=0, alinhamento=None):
        self.__qtdColunas=self.__qtdColunas+1
        col=Linha.Coluna()
        if not alinhamento:
            if tipo == 'S':
                alinhamento= 'D'
            elif tipo =='V':
                alinhamento= 'E'
            elif tipo =='N':
                alinhamento='E'
            elif tipo == 'D':
                alinhamento='D' 
            else:
                alinhamento='E'
        if posicao==0:
            posicao=self.__ultimaPosicao + 1
        col.incluirColuna(cab, tipo, tamanho, posicao, alinhamento)
        self.__ultimaPosicao=posicao+tamanho
        self.__dic_coluna[self.__qtdColunas]=col
        return True
    def formataInteiro(self, dado):
        sNumero=str(dado)
        tam=len(sNumero)
        sNovo=''
        while tam > 0:
            if tam > 3:
                sAux=sNumero[-3:]
                sNumero=sNumero[:-3]
                tam=len(sNumero)
            else:
                sAux=sNumero
                tam=0
            if sNovo == '':
                sNovo=sAux
            else:
                sNovo=sAux+'.'+sNovo
        return sNovo
    def incluirDadoColuna(self, dado, pos=0, inicializar=False):
        if inicializar:
            for x in range(self.__qtdColunas):
                col=self.__dic_coluna[x+1]
                col.dado=''
                self.__dic_coluna[x+1]=col
                self.__proximaColuna=0
                
        self.__proximaColuna=self.__proximaColuna+1
        if pos != 0:
            self.__proximaColuna=pos
        if self.__proximaColuna > self.__qtdColunas:
            return False
        col=self.__dic_coluna[self.__proximaColuna]
        if col.tipo_dados == 'S':
            col.dado=formataString(dado, col.tam_tot, ' ', col.alinhamento, 'N', 'S')
        elif col.tipo_dados == 'D':
            data=sigDatas(dado)
            if data == -1:
                return False
            col.dado=data.getDataNoFormato('N', 'S')
        elif col.tipo_dados == 'N':
            sNovo=self.formataInteiro(dado)
            col.dado=formataString(sNovo, col.tam_tot, ' ', 'E', 'N', 'S')
        else:
            lista=dado.strip('.')
            if len(lista)==1:
                sDec=formataString('0', col.tam_dec, '0', 'E', 'N', 'S')
                sInt=formataString(self.formataInteiro(dado), col.tam_int, ' ', 'E', 'N', 'S')
            elif len(lista) ==2:
                sDec=formataString(str(lista[1]), col.tam_dec, '0', 'E', 'N', 'S')
                sInt=formataString(self.formataInteiro(str(lista[0])), col.tam_int, ' ', 'D', 'N', 'S')
            else:
                return False
            sDado=sInt+','+ sDec
            col.dado=formataString(sDado, col.tam_tot, ' ', 'D', 'N', 'S')     
        self.__dic_coluna[self.__proximaColuna]=col
        return True
            
                
    def retornarCab(self):
        cab=''
        for x in range(self.__qtdColunas):
            col=self.__dic_coluna[x+1]
            pos_i=col.posicao
            if pos_i == 1:
                cab=col.cab
            else:
                cab=formataString(cab, pos_i -1, ' ', 'D', usaTrim='N', forcado='N')
                cab=cab+col.cab
        return cab
    def retornarLinha(self):
        linha=''
        for x in range(self.__qtdColunas):
            col=self.__dic_coluna[x+1]
            pos_i=col.posicao
            if pos_i == 1:
                linha=col.dado
            else:
                linha=formataString(linha, pos_i -1, ' ', 'D', usaTrim='N', forcado='N')
                linha=linha+col.dado
        return linha    
    
    
""" 
#exemplo de utilizacao de linha
from SigUtils.impressao import Linha
linha1=Linha()
linha1.incluirColuna('Codigo', 'N', 6, 1) # criando coluna
linha1.incluirColuna('Nome', 'S', 40, 10) # criando coluna
lista=[]
linha1.incluirDadoColuna(1, True) # populando linha
linha1.incluirDadoColuna('Luiz Fernando')# populando linha
lista.append(linha1.retornarLinha()) # recuperando a linha
linha1.incluirDadoColuna(2, True)# populando linha
linha1.incluirDadoColuna('Marilene de Lourde')# populando linha
lista.append(linha1.retornarLinha())
linha1.incluirDadoColuna(3, True)# populando linha
linha1.incluirDadoColuna('Luis gustavo')# populando linha
lista.append(linha1.retornarLinha())
print linha1.retornarCab()  # recuperando um cabecalho
for x in lista:
    print x
"""
class Impressora(object):
    """
        Gerar relatorios em pdf
    """
    __formato=''
    __largura=''
    __altura=''
    tamanho=[]
    __marg_esq=''
    __marg_dir=''
    __marg_sup=''
    __marg_inf=''
    marg_esq=0
    marg_dir=0
    marg_sup=0
    marg_inf=0
    cabecalhos=[]
    __rodapes=[]
    __fonte=''
    __fonteTamanho=''
    __avanco=''
    __can=''
    posicaoLinha=''
    __pagina=''
    posicaoRodape=''
    posicaoCab=''
    __jaImprimiuPrimeiraLinha=''
    __formatoPaisagem=''
    tamanhoLinha=0
    variaveis={}

    def __defineOrientacao(self, orientacao):
        if orientacao=='1':
            largura=self.__largura
            self.__largura=self.__altura
            self.__altura=largura
            self.__formatoPaisagem='S'
        else:
            self.__formatoPaisagem='N'
        self.tamanho=[]
        self.tamanho.append(self.__largura)
        self.tamanho.append(self.__altura)

    def defineFormato(self, formato='A4', orientacao='0'):
        """
            Define o formato do papel. Os tipos previstos sao A4 e letter. 
            O default eh A4
            Orientacao informa a classe para usar o formato normal ou paisagem.
                Por padrao utiliza a orientacao normal, 
                para formato paisagem usar orientacao='1'
        """
        self.__formato=formato
        A4 = 21*cm, 29.7*cm
        letter = (8.5*inch, 11*inch)
        if formato=='letter' :
            self.__largura=letter[0]
            self.__altura= letter[1]
        else:
            self.__largura=A4[0]
            self.__altura =A4[1]
        self.__defineOrientacao(orientacao)
        self.__defineMargem()

    def __defineMargem(self):
        self.__marg_esq=self.marg_esq * cm
        self.__marg_dir=self.__largura - (self.marg_dir * cm)
        self.__marg_sup=self.marg_sup * cm
        self.__marg_inf=self.__altura - (self.marg_inf * cm)
    def __substituirVariaveis(self, texto):
        for v in self.variaveis:
            texto=re.sub(v, str(variaveis[v]), texto)
        return texto

    def defineMargem(self, e=marg_esq, d=marg_dir, s=marg_sup, i=marg_inf):
        """
            Informa as margens do relatorio
        """
        self.marg_esq=e
        self.marg_dir=d
        self.marg_sup=s
        self.marg_inf=i
        self.__defineMargem()

    def informaCab(self, texto):
        """
            Informa os cabecalhos a serem utilizados pela classe.
            A ordem informada eh a ordem a ser impressa
            O uso de {{ Page }} em linhas do cabecalho forcara a incersao de numeracao de pagina em substituicao a {{ Page }}
            -- Adicionado o tratamento para formatar o numero da pagina, utilizando a tag {{ Page , 99 }} o numero da pagina 
               irá retornar formatado com a quantidade de zeros a esquerda (ex. Folha :{{ Page , 3 }} -> Impressão   Folha :005 )
        """
        texto=self.__substituirVariaveis(texto)
        self.cabecalhos.append(texto)
        
    def informaRodape(self, texto):
        """
            Informa as linhas a serem impressas no rodape das paginas.
            A ordem informada eh a ordem a ser impressa.
            Se quiser pode-se usar um rodape padrao atraves do metodo rodapePadrao()
        """
        texto=self.__substituirVariaveis(texto)
        self.__rodapes.append(texto)

    def informaTamLinha(self, tam):
        """
            Informando o tamanho da linha a classe automaticamente define o tamanho da fonte
            colunas fonte   margem  orientacao
            215     06      1       P
            187     07      1       P
            174     07      2       P
            160     06      0.50    N
            150     06      1       N
            134     06      2       N
            115     07      2       N
            100     08      2       N
            80      10      2       N
            67      12      2       N
            58      14      2       N
            50      16      2       N
            45      18      2       N
        """
        self.tamanhoLinha=tam
        if tam < 46:
            self.__defineOrientacao('0')
            self.defineFonte(tam=18)
        elif tam < 51:
            self.__defineOrientacao('0')
            self.defineFonte(tam=16)
        elif tam < 59:
            self.__defineOrientacao('0')
            self.defineFonte(tam=14)
        elif tam < 68:
            self.__defineOrientacao('0')
            self.defineFonte(tam=12)
        elif tam < 81:
            self.__defineOrientacao('0')
            self.defineFonte(tam=10)
        elif tam < 101:
            self.__defineOrientacao('0')
            self.defineFonte(tam=8)
        elif tam < 116:
            self.__defineOrientacao('0')
            self.defineFonte(tam=7)
        elif tam < 135:
            self.__defineOrientacao('0')
            self.defineFonte(tam=6)
        elif tam < 151:
            self.__defineOrientacao('0')
            self.defineFonte(tam=6)
        elif tam < 161:
            self.__defineOrientacao('0')
            self.defineFonte(tam=6)
        elif tam < 175:
            self.__defineOrientacao('1')
            self.defineFonte(tam=7)
        elif tam < 188:
            self.__defineOrientacao('1')
            self.defineFonte(tam=7)
        else:
            self.__defineOrientacao('1')
            self.defineFonte(tam=6)
        self.defineMargem(self.marg_esq, self.marg_dir, self.marg_sup, self.marg_inf)


    def rodapePadrao(self):
        """
            Informa a classe para utilizar o rodape padrao.
            Se havia rodape ja informado, sera desconsiderado e valera o rodape padrao
        """
        self.__rodapes=[]
        qtdEspacos= int(self.tamanhoLinha - 21 - (self.tamanhoLinha * 0.1))
        rodape = ' ' * qtdEspacos + "Sig Informatica Ltda."
        #self.informaRodape('         1         2         3         4         5         6         7         8         9         0         1         2         3         4         5         6         7         8         9         0')
        #self.informaRodape('12345678901234567890123456789012345678901234567890123456789012345678901234567890123456789012345678901234567890123456789012345678901234567890123456789012345678901234567890123456789012345678901234567890')
        self.informaRodape('--')
        self.informaRodape(rodape)

    def defineFonte(self, fonte='Courier-Bold', tam=10):
        """
            Informa a fonte a o tamanho a ser utilizado em todo relatorio.
            se tam = '*', nao define tamanho
        """
        self.__fonte=fonte
        if tam != '*':
            self.__fonteTamanho=tam
            self.__avanco=tam * 1.3

    def informaNome(self, nome, title=None):
        """
            Informa o nome e titulo que sera utilizado na geracao do relatorio
        """
        if not title:
            title = 'SigERP'
        self.__can = canvas.Canvas(nome, self.tamanho)
        self.__can.setTitle(title)

    def imprimeLinha(self, texto):
        """
            Imprime as linhas do relatorio.
            se usar '--' sera impresso uma linha da margem esquerda ate a direita
            se usar {{ Page }} (exatamente desta forma) forcara o avanco de pagina.
        """
        texto=self.__substituirVariaveis(texto)
        if self.__jaImprimiuPrimeiraLinha == 'N':
            self.cab()
            self.__jaImprimiuPrimeiraLinha='S'
        if texto == '{{ Page }}':
            self.__can.showPage()
            self.cab()
        else:
            if texto == '--':
                self.posicaoLinha = self.posicaoLinha - self.__avanco
                posicaoLinha = self.posicaoLinha + (self.__avanco / 2)
                self.__can.line(self.__marg_esq, posicaoLinha, self.__largura - self.__marg_esq, posicaoLinha)
            else:
                self.posicaoLinha = self.posicaoLinha - self.__avanco
                if self.posicaoLinha < self.posicaoRodape:
                    self.__can.showPage()
                    self.cab()
                    self.posicaoLinha -= self.__avanco  # Primeira linha após o cabecalho.
                if texto.startswith('{{ bold }}'):
                    texto = texto[10:]
                    self.__can.drawString(self.__marg_esq, self.posicaoLinha, "%s" % texto)
                    self.__can.drawString(self.__marg_esq+0.15, self.posicaoLinha+0.15, "%s" % texto)
                else:
                    self.__can.drawString(self.__marg_esq, self.posicaoLinha, "%s" % texto)

    def finalizaImpressao(self):
        """
            Finaliza o relatorio, gerando o arquivo pdf
        """
        self.__can.showPage()
        self.__can.save()
        
    def setPage(self,pagina):
        """
            Função para setar o Nro. da Pagina a ser impressa.
        """
        self.__pagina= pagina
        
    def getPage(self):
        """
            Função retorna o Nro da pagina
        """
        return self.__pagina
        
    def cab(self):
        self.__pagina=self.__pagina + 1
        self.__can.setFont(self.__fonte, self.__fonteTamanho)
        self.__can.setLineWidth(1)
        qtdRodape=len(self.__rodapes)
        self.posicaoRodape=self.__altura - self.__marg_inf + (qtdRodape * self.__avanco)
        posicao=self.posicaoRodape
        for x in self.__rodapes:
            posicao=posicao - self.__avanco
            if x == '--':
                posicaoLinha = posicao + (self.__avanco / 2)
                self.__can.line(self.__marg_esq, posicaoLinha, self.__largura - self.__marg_esq, posicaoLinha)
            else:
                 self.__can.drawString(self.__marg_esq, posicao, "%s" % x)

        self.posicaoCab=self.__altura - self.__marg_sup
        for x in self.cabecalhos:
            self.posicaoCab = self.posicaoCab - self.__avanco
            if x == '--':
                posicaoLinha = self.posicaoCab + (self.__avanco / 2)
                self.__can.line(self.__marg_esq, posicaoLinha, self.__largura - self.__marg_esq, posicaoLinha)
            else:
                iinit = x.find('{{ Page')
                icom = x.find(',',iinit)
                ifim = x.find('}}',iinit)
                itam = 1
                spg = '{{ Page }}'
                if ifim > iinit:
                    if (icom > iinit) and (icom < ifim ):                    
                        try:
                            itam = int(x[icom+1:ifim].strip())
                            spg = x[iinit:ifim+2]
                        except:
                            pass
                
                if spg:    
                    texto=re.sub(spg, str(self.__pagina).rjust(itam,'0'), x)
                else:
                    texto= x
            
                self.__can.drawString(self.__marg_esq, self.posicaoCab, texto)
        self.posicaoLinha = self.posicaoCab

    def __init__(self):
        """
            Inicializa a classe para geracao de relatorios em pdf
        """
        self.defineFormato('A4')
        self.defineFonte()
        self.__pagina=0
        self.cabecalhos=[]
        self.__rodapes=[]
        self.__jaImprimiuPrimeiraLinha='N'
        self.marg_esq=0.5
        self.marg_dir=0.5
        self.marg_sup=2
        self.marg_inf=1
        self.tamanhoLinha=0
        self.variaveis={}

#i=Impressora()
##i.defineFormato('A4', '1')
#i.informaTamLinha(200)
#i.informaNome('/tmp/teste.pdf')
##i.defineMargem(1,1,2,1)
#i.rodapePadrao()
#cab1= 'Controle de Estoque              Cadastro de Itens                      Pag.: {{ Page }}'
#cab2= 'Data 06/03/2008              empresa de teste Ltda.                      est350'
#cab4= 'Codigo Descricao                                      Quantidade       Valor   '
#i.informaCab(cab1)
#i.informaCab(' ')
#i.informaCab(cab2)
#i.informaCab(' ')
#i.informaCab('--')
#i.informaCab(cab4)
#i.informaCab('--')
#i.informaCab(' ')
#lin=[]
#lin.append('000001 primeiro item                                           1          10,00')
#lin.append('000002 Segundo  item                                           2          10,00')
#lin.append('000003 Tercerio item                                           3          10,00')
#lin.append('000004 Quarto   item                                           4          10,00')
#lin.append('000005 quinto   item                                           5          10,00')
#lin.append('000006 Sexto    item                                           6          10,00')
#for a in range(100):
#    for b in range(6):
#        i.imprimeLinha(lin[b])
#    #i.imprimeLinha('--')
#    #i.imprimeLinha('{{ Page }}')
#i.finalizaImpressao()
#
