# -*- encoding: utf-8 -*-

__Autor__ = "Luiz Fernando"
__Empresa__ = "Sig Informatica Ltda"
__Site__ = "http://www.siginformatica.com.br"
__Versao__ = "1.01"
__DataAlteracao__ = "31/07/2013"
__lista_pk = b'x\x9c\x0b\xceLw\r\n\xd0\r\xce,.I\xcdMT\xf0\xcc+I\xcd\xc9LO\x05R\n)\xa9\n\xee\xa9\xc5%\x89\xf9\x8a\x00\xfb:\r3'

import zlib
import psycopg2
from SigUtils import crypto
from SigUtils import datas
from odoo.tools import config
from odoo.fields import datetime as field_datetime

def _crypto_sig(encripta_decripta, dados):
    _pk = zlib.decompress(__lista_pk)
    if encripta_decripta.lower() == 'e':
        return crypto.encrypt(dados, _pk).decode('utf-8')
    if encripta_decripta.lower() == 'd':
        return crypto.decrypt(dados, _pk).decode('utf-8')
    return False


def getEmpresa(self, tabela=None, args=None, user_company_id=False):
    """
    Funcao getEmpresa,
    - retorna a empresa padrao do usuario ou a empresa a ser utilizada para uma determinada tabela, conforme adm.empresa.objeto
    - se nao informar args, usara a empresa default do usuario
    - Args pode ser o numero da empresa ou um conjunto de argumentos do tipo [('n','=', 'n)]
    - Se args for numero de empresa ou se nao informar tabela, o retorno sera um id de empresa
    - Se arqs for do tipo argumento, o retorno sera tambem do tipo argumento
    """
    company_id = user_company_id
    _spg = self.env.get
    if not company_id:
        if self.env.context.get('sig_force_company') and self.env.context.get(
                'sig_force_company') != True:
            company_id = self.env.context.get('sig_force_company')
        else:
            company_id = self.env.company.id
    if not tabela:
        return company_id
    if args:
        try:
            company_id = int(args)
        except:
            for arg in args:
                if arg[0] == 'company_id':
                    company_id = arg[2]
                    break
    result = company_id
    res = _spg('ir.model').search([('model', '=', tabela)])
    if not res:
        return result
    if isinstance(company_id, (int, int)):
        company_id = [company_id]
    ids = _spg('adm.empresa.objeto').search([('empresa_escolhida_id', 'in', company_id),
                                             ('ir_model_id', '=', res.id)])
    if ids:
        res = ids.read(['empresa_a_usar_id'], load='_classic_write')[0]
        if res:
            result = res['empresa_a_usar_id']
    if not args:
        return result
    try:
        integer = int(args)
        args1 = result
    except:
        if not args:
            args1 = [('company_id', '=', result)]
        else:
            args1 = [('company_id', '=', result)]
            for arg in args:
                if arg[0] != 'company_id':
                    args1.append(arg)
    return args1


def _get_licensa_sig_erp(self):
    """
    Função para verificar a licensa do SigERP
    Retorna:
        - False quando não tem licensa ou
        - dicionario com dias para vencer, qtd empresas, qtd usuarios, lista de modulos
    """
    def _ativar_pedido_de_validacao(self):
        objCron = self.env.get('ir.cron')
        self.env.cr.execute("select id from ir_cron where name ='Validar o sistema'")
        res = self.env.cr.dictfetchone()
        id = False
        if res:
            id = res['id']
        ids = [id]
        vals = {
            'numbercall': 1,
            'active': True,
        }
        try: # Qdo o cron está em execução, não é possivel alterá-lo
            objCron.browse(ids).write(vals)
        except:
            pass
        return True

    self.env.cr.execute("select * from ir_module_module where name = 'adm' and state = 'installed'")
    dados = self.env.cr.dictfetchone()
    if not dados:
        return True
    licensa = self.env.get('ir.config_parameter').get_param('licensa_sig_erp')
    self.env.cr.execute('select cpf_cnpj from adm_pessoa where id = 2')
    dados = self.env.cr.dictfetchone()
    _cnpj = str(dados['cpf_cnpj']).replace('.', '').replace('-', '').replace('/', '')
    if not licensa or licensa == '12345':
        _ativar_pedido_de_validacao(self)
        return False
    dados_licensa = _crypto_sig('d', licensa).split(';')
    if _cnpj != dados_licensa(0) or '00000000' == dados_licensa(1):
        _ativar_pedido_de_validacao(self)
        return False
    dias = datas.calcDiferenca(datas.getDataDeHoje(), dados_licensa(1))
    if dias < 1:
        _ativar_pedido_de_validacao(self)
    if dias < -10:
        return False
    return {
        'dias': dias,
        'empresas': dados_licensa(2),
        'usuarios': dados_licensa(3),
        'modulos': dados_licensa(4)
    }

def search(self, args, offset=0, limit=None, order=None, count=False):
    #Quando houver no contexto "sig_force_company", não será feito nenhum tratamento no args
    # liberar apartir da versao 4A
    # if not context.get('install_mode'):
    #     if not (self._name.startswith('ir.') or
    #             self._name.startswith('res.') or
    #             self._name.startswith('base.') or
    #             self._name.startswith('adm.monitor.')):
    #         if not _get_licensa_sig_erp(self, cr, user):
    #             limit = 5
    if self.env.context.get('sig_force_company'):
        _sig_force_company = self.env.context.get('sig_force_company')
        if isinstance(_sig_force_company, bool):
            if self.env.context.get('sig_force_company') == True:
                return args, offset, limit, order, count
    if 'parametro' in self._name and not self._name == 'financeiro.parametros.cobranca':
        if not hasattr(self, 'company_id'):
            return args, offset, limit, order, count

        if 'all' in args:
            args = []
        else:
            # tem que passar o company_id caso o cron esteja executando a importacao de cupom,
            # no caso de multi-empresa para nao pegar o parametro de outra empresa.
            arg_company = list(filter(lambda x: x[0] == 'company_ids', args))
            user_company_id = arg_company and arg_company[0][2] or False
            company_id = getEmpresa(self, self._name, user_company_id=user_company_id)
            args = [('company_id', '=', company_id)]
    else:
        company_id = _ajustar_empresa(self, False)
        if company_id:
            args_temp = list(filter(lambda i: 'company_id' not in i, args))
            #Qdo no contexto tiver "sig_search_sem_filhos", não será feito tratamento para empresas filhas
            if not self.env.context.get('sig_search_sem_filhos'):
                company_ids = self.env.get('res.company').search([('parent_id', 'child_of', [company_id])]).ids
                if company_ids:
                    company_ids.append(company_id)
                    args_temp.append(('company_id', 'in', list(set(company_ids))))
                else:
                    args_temp.append(('company_id', '=', company_id))

            else:
                args_temp.append(('company_id', '=', company_id))
            args = args_temp
    return args, offset, limit, order, count

def name_search(self, name='', args=None, operator='ilike', limit=100):
    #Quando houver no contexto "sig_force_company", não será feito nenhum tratamento no args

    if self.env.context.get('sig_force_company'):
        return name, args, operator, limit

    if 'parametro' in self._name and not self._name == 'financeiro.parametros.cobranca':
        if hasattr(self, 'company_id'):
            return name, args, operator, limit

        if 'all' in args:
            args = []
        else:
            # tem que passar o company_id caso o cron esteja executando a importacao de cupom,
            # no caso de multi-empresa para nao pegar o parametro de outra empresa.
            arg_company = list(filter(lambda x: x[0] == 'company_ids', args))
            user_company_id = arg_company and arg_company[0][2] or False
            company_id = getEmpresa(self, self._name, user_company_id=user_company_id)
            args = [('company_id', '=', company_id)]
    else:
        company_id = _ajustar_empresa(self, False)
        if company_id:
            args_temp = list(filter(lambda i: 'company_id' not in i, args))
            #Qdo no contexto tiver "sig_search_sem_filhos", não será feito tratamento para empresas filhas
            if not self.env.context.get('sig_search_sem_filhos'):
                company_ids = self.env.get('res.company').search([('parent_id', 'child_of', [company_id])]).ids
                if company_ids and company_id not in company_ids:
                    company_ids.append(company_id)
                    args_temp.append(('company_id', 'in', list(set(company_ids))))
                else:
                    args_temp.append(('company_id', '=', company_id))
            else:
                args_temp.append(('company_id', '=', company_id))
            args = args_temp
    return name, args, operator, limit


def _ajustar_empresa(self, company_id):
    tabelas = ['adm.empresa.objeto', 'legado.empresa', 'ir.values', 'res.company', 'res.users', 'ir.sequence',
               'adm.pessoa', 'res.partner']
    try:
        if self._name in tabelas or not hasattr(self, 'company_id'):
            return company_id
        if not self.env.context.get('sig_force_company', False):
            return getEmpresa(self, self._name)
        emp = self.env.context.get('sig_force_company')
        if isinstance(emp, bool):
            return company_id
        return getEmpresa(self, self._name, user_company_id=emp)
    except:
        pass
    return company_id

def _ajustar_vals(self, vals):
    if isinstance(vals, dict):
        if 'write_date' in vals:
            vals.pop('write_date')
        if 'write_uid' in vals:
            vals.pop('write_uid')
    company_id = _ajustar_empresa(self, vals.get('company_id', False))
    if company_id:
        vals['company_id'] = company_id
    return vals

def write(self, vals):
    if 'company_id' in vals: # NO write só ajustar se veio empresa no vals
        return _ajustar_vals(self, vals)
    return vals

def create(self, vals):
    return _ajustar_vals(self, vals)

def _get_sig_server(servidor):
    return _crypto_sig('d', servidor)

def _set_sig_server(host, bd, porta, user, passwd):
    if not host:
        host = 'erp.siginformatica.com.br'
    if not bd:
        bd = 'erp'
    if not porta:
        porta = '8069'
    if not user:
        user = 'remoto'
    if not passwd:
        passwd = 'remo102938'
    lista = str(host) + ',' + str(bd) + ',' + str(porta) + ',' + str(user) + ',' + str(passwd)
    return _crypto_sig('e', lista)


class db_sig:
    def __init__(self, base, **kargs):
        self.base = base
        if kargs.get('host'):
            self.dbhost = kargs.get('host')
        else:
            self.dbhost = None
        if kargs.get('port'):
            self.dbport = kargs.get('port')
        else:
            self.dbport = None
        if kargs.get('pwd'):
            self.dbpass = kargs.get('pwd')
        else:
            self.dbpass = None
        if kargs.get('user'):
            self.dbuser = kargs.get('user')
        else:
            self.dbuser = None
        if kargs.get('uid'):
            self.uid = kargs.get('uid')
        else:
            self.uid = False
        self.cr = self._dbsNewConnection()

    def _dbsNewConnection(self):
        if not self.dbuser:
            self.dbuser = config.options.get('db_user')
        if not self.dbpass:
            self.dbpass = config.options.get('db_password') or None
        if not self.dbhost:
            self.dbhost = config.options.get('db_host') or '127.0.0.1'
        if not self.dbport:
            self.dbport = config.options.get('db_port') or '5432'
        self.conexao = psycopg2.connect(database=self.base,
                                   user=self.dbuser,
                                   password=self.dbpass,
                                   host=self.dbhost,
                                   port=self.dbport,
                                   connect_timeout=3)
        _cr = self.conexao.cursor()
        return _cr

    def _dbsDictfetchall(self, cr):
        """Retorna todas as linhas de um cursor como um dicionario"""
        desc = cr.description
        return [dict(zip([col[0] for col in desc], row)) for row in cr.fetchall()]

    def dbsSelect(self, table, fields=[], where=[], order_by=[], limit=0):
        _cr = self.cr
        if not fields:
            sql_fields_from = "* from"
        else:
            fields = tuple(fields)
            str_fields = "%s, " * fields.__len__()
            sql_fields_from = str_fields % fields
            sql_fields_from += "from"
            sql_fields_from = sql_fields_from.replace(", from", " from")
        sql_where = ""
        if where:
            for i in where:
                column = i[0]
                operator = i[1]
                value = i[2]
                if isinstance(value, tuple):
                    str_value = "%s" % str(value).replace(',)', ')')
                else:
                    str_value = "'%s'" % str(value)
                sql_where += "%s %s %s and " % (column, operator, str_value)
        sql_order_by = ""
        if order_by:
            orders = tuple(order_by)
            str_order = "%s, " * orders.__len__()
            sql_order_by = str_order % orders
        sql_sentenca = "select %s %s" % (sql_fields_from, table)
        # WHERE
        if sql_where:
            sql_where += ";"
            sql_sentenca += " where %s" % sql_where.replace(" and ;", ";")
        else:
            sql_sentenca += ";"
        # ORDER BY
        if sql_order_by:
            sql_order_by += ';'
            sql_sentenca = sql_sentenca.replace(';', ' order by %s' % sql_order_by.replace(', ;', ';'))
        if limit:
            sql_sentenca = sql_sentenca.replace(';', ' limit %d;' % limit)
        try:
            _cr.execute(sql_sentenca)
            return self._dbsDictfetchall(_cr)
        except:
            return False

    def dbsInsert(self, table, vals, many2many=False):
        """
        @param table: Tabela que recebera a insercao
        @type table: string
        @param vals: Colunas e respectivos valores a serem inseridos
        @type vals: dict
        @param many2many: Indica que a insercao sera feita em uma tabela m2m
        @type many2many: bool
        @return: ID da insercao ou True se a tabela for m2m
        @rtype: integer or bool
        """
        _cr = self.cr
        if not many2many:
            if not 'create_date' in vals:
                # vals['create_date'] = datetime.now().strftime('%Y-%m-%d %H:%M:%S')
                vals['create_date'] = vals['write_date'] = field_datetime.now()
            if self.uid and not 'create_uid' in vals:
                vals['create_uid'] = vals['write_uid'] = self.uid
        fields = tuple(vals.keys())
        values = tuple(vals.values())
        str_fields = "%s, " * fields.__len__()
        str_values = "'%s', " * values.__len__()
        sql_fields = str_fields % fields
        sql_values = str_values % values
        sql_sentenca = "insert into %s (%s) values (%s) " % (table, sql_fields, sql_values)
        sql_sentenca = sql_sentenca.replace(", )", ")")
        if not many2many:
            sql_sentenca += "returning id;"
        else:
            sql_sentenca += ";"
        sql_sentenca = sql_sentenca.replace("'null'", "null").replace("'Null'", "null")
        _cr.execute(sql_sentenca)
        if many2many:
            return True
        else:
            return (_cr.fetchone() or [False])[0]

    def dbsUpdate(self, table, values={}, where=[], many2many=False):
        """
        @param table: Tabela a ser atualizada
        @type table: string'
        @param values: Colunas e respectivos valores
        @type values: dicionario
        @param where: Clausulas para atualizacao
        @type where: lista de tuplas
        @return: True or False
        @rtype: boolean
        """
        _cr = self.cr
        if not many2many:
            # values['write_date'] = datetime.now().strftime('%Y-%m-%d %H:%M:%S')
            values['write_date'] = field_datetime.now()
            if self.uid:
                values['write_uid'] = self.uid
        sql_fields_values = ""
        for column, value in values.items():
            sql_fields_values += "%s = '%s', " % (column, str(value))
        sql_where = ""
        if where:
            for i in where:
                column = i[0]
                operator = i[1]
                value = i[2]
                if isinstance(value, tuple):
                    str_value = "%s" % str(value).replace(',)', ')')
                else:
                    str_value = "'%s'" % value
                sql_where += "%s %s %s and " % (column, operator, str_value)
        sql_sentenca = "update %s set %s" % (table, sql_fields_values)
        if sql_where:
            sql_where += ";"
            sql_sentenca += "where %s" % sql_where.replace(" and ;", ";")
            sql_sentenca = sql_sentenca.replace(', where', ' where')
        else:
            sql_sentenca += ";"
            sql_sentenca = sql_sentenca.replace(', ;', ';')
        sql_sentenca = sql_sentenca.replace("'null'", "null").replace("'Null'", "null")
        _cr.execute(sql_sentenca)
        return True

    def dbsDelete(self, table, where=[]):
        """
        @param table: Tabela a ser deletada
        @type table: string
        @param where: Condicoes para a delecao
        @type where: lista de tuplas
        @return: True or False
        @rtype: bool
        """
        _cr = self.cr
        sql_where = ""
        if where:
            for i in where:
                column = i[0]
                operator = i[1]
                value = i[2]

                if isinstance(value, tuple):
                    str_value = "%s" % str(value).replace(',)', ')')
                else:
                    str_value = "'%s'" % value
                sql_where += "%s %s %s and " % (column, operator, str_value)
        sql_sentenca = "delete from %s" % table
        if sql_where:
            sql_where += ";"
            sql_sentenca += " where %s" % sql_where.replace(" and ;", ";")
            sql_sentenca = sql_sentenca.replace(', where', ' where')
        else:
            sql_sentenca += ";"
        _cr.execute(sql_sentenca)
        return True

